package com.iformall.controller.market;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.WxActivity;
import com.iformall.enums.EnumActivityStatus;
import com.iformall.exception.MallinkException;
import com.iformall.service.WxActivityService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author gongbiao
 */
@RestController
@RequestMapping("wxActivity")
@Api(description = "活动")
public class WxActivityController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxActivityService wxActivityService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "活动-列表")
    public ResultData list(@ModelAttribute WxActivity wxActivity, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxActivityController::list");
        if (null == wxActivity) wxActivity = new WxActivity();
        if (wxActivity.getStatus() != null && wxActivity.getStatus() == -1) {
            wxActivity.setStatus(null);
        }
        wxActivity.setTenantId(getTenantId());
        wxActivity.setSortColumns(BaseEntity.SortField.CreateTime_DESC,BaseEntity.SortField.Id_DESC);
        final PageInfo<WxActivity> page = wxActivityService.listAsPage(wxActivity, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "活动-新增")
    public ResultData add(@RequestBody WxActivity wxActivity) {
        logger.debug("[" + getIpAddr() + "] WxActivityController::add");
        wxActivity.setStatus(EnumActivityStatus.STATUS_THROW_IN.getCode());
        wxActivity.setTenantId(getTenantId());
        try {
            wxActivityService.saveOrUpdate(wxActivity);
        } catch (MallinkException e) {
            logger.error(e.getMessage());
            return new ResultData(e.getErrorCode(), e.getMessage());
        }
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "活动-id更新")
    public ResultData update(@RequestBody WxActivity wxActivity) {
        logger.debug("[" + getIpAddr() + "] WxActivityController::update");
        try {
            return wxActivityService.saveOrUpdate(wxActivity);
        } catch (MallinkException e) {
            logger.error(e.getMessage());
            return new ResultData(e.getErrorCode(), e.getMessage());
        }
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("updateStatus")
    @SystemControllerLog(description = "活动-更新状态")
    public ResultData updateStatus(@RequestBody WxActivity wxActivity) {
        logger.debug("[" + getIpAddr() + "] WxActivityController::updateStatus");
        return wxActivityService.updateStatus(wxActivity);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "活动-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxActivityController::findById");
        WxActivity wxActivity = wxActivityService.getById(id);
        return new ResultData(Result.SUCCESS, "查询成功", wxActivity);
    }

    @ApiOperation("投放到宣传页")
    @GetMapping("/sendToCampaign")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "活动-投放到宣传页")
    public ResultData sendToCampaign(Long id) {
        logger.debug("[" + getIpAddr() + "] WxActivityController::sendToCampaign");
        return wxActivityService.sendToCampaign(id);
    }

}
